use inc::Module::Install;

name("tfam_lib");
version_from("tfam.in");
author("David H. Ardell <http://www.lcb.uu.se/~dave>");
license("academic free");
requires('perl' => '5.004','Bio::SeqIO' => '1.2.3','IO::File' => 0.8);
requires_external_cc;
install_script("tfam");
check_nmake();
%settings = (
	     'LIB' => '/usr/local/lib/tfam', 
	     'OBJECT' => 'tfam_lib.o tfam_lib_wrap.o',
	     'DIR' => ['covemf-2.4.4'], 
);	     
WriteMakefile(%settings);

## get setting of LIB variable and PERL
@lib = grep {/^LIB=/} @ARGV;
if (@lib > 1) {
  die "Please check that you have set \"LIB\" only once when you run Makefile.PL.\nIf error persists please contact author.\n";
}
elsif (@lib == 1) {
  $lib[0] =~ s/LIB=//;
  $lib = $lib[0];
}
else {
  $lib = $settings{'LIB'};
}

## update installation-settings in TFAM file
print STDERR "\n\ngenerating executable tfam file....";
$tfamin = 'tfam.in';
$tfam   = 'tfam';
open(FI, "< $tfamin")       or die "can't read $tfamin: $!";
open(FO, "> $tfam")         or die "can't read $tfam: $!";
while (<FI>) {
  if (/perl -w/) {
      print FO $_;
      print FO "# this script was automatically generated by Makefile.PL\n";
      print FO "# from tfam.in. Modify tfam.in, not this file, if you\n";
      print FO "# want to use Makefile.PL to install your modified version.\n";
    }
  else {
    s/XX_LIB_XX/$lib/g;
    print FO $_;
  }
}
close(FI)                    or die "can't close $tfamin: $!";
close(FO)                    or die "can't close $tfam: $!";
unless (chmod (0774,$tfam)) {warn "hmm... couldn't chmod $tfam.$!";}
print STDERR " done.\n";

print STDERR "\nTFAM is ready for installation\n";
print STDERR "default files used by tfam\n";
print STDERR "will be put here: $lib\n";
print STDERR "after you 'make install'\n";
print STDERR "you can change this location by running\n";
print STDERR "perl Makefile.PL LIB=<new_place>\n";
print STDERR "now before you make install.\n";
print STDERR "Rerun perl Makefile.PL to tell tfam where\n";
print STDERR "to find these files if you later want them\n";
print STDERR "somewhere else.\n\n";
