/* Name: tfam_lib.c
 * Purpose: Division and log of 2Darrays, to be used by functions written in Perl. 
 * Requires: tfam_lib.i, tfam_lib_wrap.c,tfam_lib.so, tfam_lib.pm, main function(Perl)
 * Developed w/ swig
 *
 * Author: Helena Tåquist, tue aug 8 2006
 *
 */


#include <stdio.h>
#include <stdlib.h>


double log(double);
typedef double* MATDIM1;

MATDIM1*  log_array(MATDIM1*, int, int);
MATDIM1*  divide(MATDIM1* mat1,MATDIM1* mat2, int c, int r);


MATDIM1* divide(MATDIM1* mat1, MATDIM1* mat2, int c, int r )  
        { 
	    
	    int i, j;
 	    MATDIM1* div2D;
	    
	    div2D = (MATDIM1*)malloc(c * sizeof(MATDIM1)); 
	    for (i =0; i<c; i++){
		div2D[i] = (MATDIM1)malloc(r * sizeof(double)); 
	    }
	   
	/*Elementwise division*/
	    for(i = 0 ; i < c ; i++){
		for(j = 0 ; j < r ; j++) {
		    div2D[i][j] = mat1[i][j] / mat2[i][j];
		}
	    }
	    return div2D;
	}

MATDIM1* log_array(MATDIM1* mat1, int c, int r)  
        {
	    int i, j;
	    MATDIM1* log2D;
	    
	    log2D = (MATDIM1*)malloc(c * sizeof(MATDIM1));
	    for (i =0; i<c; i++){
		log2D[i] = (MATDIM1)malloc(r * sizeof(double)); 
	    }
	    
	    /*log*/
	    for(i = 0 ; i < c ; i++){
		for(j = 0 ; j < r ; j++) {
		    log2D[i][j] = log(mat1[i][j]);
		}
	    }
	    return log2D;
	}
